Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2232)
@@ -1090,166 +1120,235 @@
                 qv1            !< specific humidity at first grid level
 
+    TYPE(surf_type_lsm), POINTER ::  surf_t_surface
+    TYPE(surf_type_lsm), POINTER ::  surf_t_surface_p
+    TYPE(surf_type_lsm), POINTER ::  surf_tt_surface_m
+    TYPE(surf_type_lsm), POINTER ::  surf_m_liq_eb
+    TYPE(surf_type_lsm), POINTER ::  surf_m_liq_eb_p
+    TYPE(surf_type_lsm), POINTER ::  surf_tm_liq_eb_m
+
+    TYPE(surf_type_lsm), POINTER ::  surf_m_soil
+    TYPE(surf_type_lsm), POINTER ::  surf_t_soil
+
+    TYPE(surf_type), POINTER  ::  surf  !< surface-date type variable
+
+    IF ( horizontal )  THEN
+       surf              => surf_lsm_h
+
+       surf_t_surface    => t_surface_h
+       surf_t_surface_p  => t_surface_h_p
+       surf_tt_surface_m => tt_surface_h_m
+       surf_m_liq_eb     => m_liq_eb_h
+       surf_m_liq_eb_p   => m_liq_eb_h_p
+       surf_tm_liq_eb_m  => tm_liq_eb_h_m
+       surf_m_soil       => m_soil_h
+       surf_t_soil       => t_soil_h
+
+       k_off     = -1
+       j_off     = 0
+       i_off     = 0
+    ELSE
+       surf              => surf_lsm_v(l)
+
+       surf_t_surface    => t_surface_v(l)
+       surf_t_surface_p  => t_surface_v_p(l)
+       surf_tt_surface_m => tt_surface_v_m(l)
+       surf_m_liq_eb     => m_liq_eb_v(l)
+       surf_m_liq_eb_p   => m_liq_eb_v_p(l)
+       surf_tm_liq_eb_m  => tm_liq_eb_v_m(l)
+       surf_m_soil       => m_soil_v(l)
+       surf_t_soil       => t_soil_v(l)
+
+       k_off = 0
+       IF ( l == 0 )  THEN 
+          j_off = -1 
+          i_off = 0
+       ELSEIF ( l == 1 )  THEN 
+          j_off = 1 
+          i_off = 0
+       ELSEIF ( l == 2 )  THEN 
+          j_off = 0 
+          i_off = -1
+       ELSEIF ( l == 3 )  THEN 
+          j_off = 0 
+          i_off = 1
+       ENDIF
+    ENDIF
+
 !
 !-- Calculate the exner function for the current time step
     exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 
-    DO  i = nxlg, nxrg
-       DO  j = nysg, nyng
-          k = nzb_s_inner(j,i)
-
-!
-!--       Set lambda_surface according to stratification between skin layer and soil
-          IF (  .NOT.  pave_surface(j,i) )  THEN
-
-             c_surface_tmp = c_surface
-
-             IF ( t_surface(j,i) >= t_soil(nzb_soil,j,i))  THEN
-                lambda_surface = lambda_surface_s(j,i)
-             ELSE
-                lambda_surface = lambda_surface_u(j,i)
-             ENDIF
+    DO  m = 1, surf%ns
+
+       i   = surf%i(m)            
+       j   = surf%j(m)
+       k   = surf%k(m)
+!
+!--    Determine height index for radiation. Note, in clear-sky case radiation
+!--    arrays have rank 0 in first dimensions, so index must be zero. In case
+!--    of RRTMG radiation arrays have non-zero rank in first dimension, so that 
+!--    radiation can be obtained at respective height level
+       k_rad = MERGE( 0, k + k_off, radiation_scheme /= 'rrtmg' )
+!
+!--    Set lambda_surface according to stratification between skin layer and soil
+       IF (  .NOT.  surf%pave_surface(m) )  THEN
+
+          c_surface_tmp = c_surface
+
+          IF ( surf_t_surface%var_1d(m) >= surf_t_soil%var_2d(nzb_soil,m))  THEN
+             lambda_surface = surf%lambda_surface_s(m)
           ELSE
-
-             c_surface_tmp = pave_heat_capacity * dz_soil(nzb_soil) * 0.5_wp
-             lambda_surface = pave_heat_conductivity * ddz_soil(nzb_soil)
-
-          ENDIF
-
-!
-!--       First step: calculate aerodyamic resistance. As pt, us, ts
-!--       are not available for the prognostic time step, data from the last
-!--       time step is used here. Note that this formulation is the
-!--       equivalent to the ECMWF formulation using drag coefficients
-          IF ( cloud_physics )  THEN
-             pt1 = pt(k+1,j,i) + l_d_cp * pt_d_t(k+1) * ql(k+1,j,i)
-             qv1 = q(k+1,j,i) - ql(k+1,j,i)
-          ELSE
-             pt1 = pt(k+1,j,i)
-             qv1 = q(k+1,j,i)
-          ENDIF
-
-          r_a(j,i) = (pt1 - pt(k,j,i)) / (ts(j,i) * us(j,i) + 1.0E-20_wp)
-
-!
-!--       Make sure that the resistance does not drop to zero for neutral 
-!--       stratification
-          IF ( ABS(r_a(j,i)) < 1.0_wp )  r_a(j,i) = 1.0_wp
-
-!
-!--       Second step: calculate canopy resistance r_canopy
-!--       f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
+             lambda_surface = surf%lambda_surface_u(m)
+          ENDIF
+       ELSE
+
+          c_surface_tmp = pave_heat_capacity * dz_soil(nzb_soil) * 0.5_wp
+          lambda_surface = pave_heat_conductivity * ddz_soil(nzb_soil)
+
+       ENDIF
+
+!
+!--    First step: calculate aerodyamic resistance. As pt, us, ts
+!--    are not available for the prognostic time step, data from the last
+!--    time step is used here. Note that this formulation is the
+!--    equivalent to the ECMWF formulation using drag coefficients
+       IF ( cloud_physics )  THEN
+          pt1 = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
+          qv1 = q(k,j,i) - ql(k,j,i)
+       ELSE
+          pt1 = pt(k,j,i)
+          qv1 = q(k,j,i)
+       ENDIF
+!
+!--    Calculate aerodynamical resistance. For horizontal and vertical 
+!--    surfaces MOST is applied. Moreover, for vertical surfaces, resistance
+!--    can be obtain via parameterization of Mason (2000) / 
+!--    Krayenhoff and Voogt (2006).
+!--    To do: detailed investigation which approach is better!
+       IF ( horizontal  .OR.  .NOT. aero_resist_kray )  THEN
+          surf%r_a(m) = ( pt1 - surf_lsm_h%pt_surface(m) ) /                   &
+                        ( surf%ts(m) * surf%us(m) + 1.0E-20_wp )
+       ELSE
+          surf%r_a(m) = 1.0_wp / ( 11.8_wp + 4.2_wp *                          &
+                        SQRT( ( ( u(k,j,i) + u(k,j,i+1) ) * 0.5_wp )**2 +      &
+                              ( ( v(k,j,i) + v(k,j+1,i) ) * 0.5_wp )**2 +      &
+                              ( ( w(k,j,i) + w(k-1,j,i) ) * 0.5_wp )**2 )      &
+                                 )
+       ENDIF
+!
+!--    Make sure that the resistance does not drop to zero for neutral 
+!--    stratification
+       IF ( ABS( surf%r_a(m) ) < 1.0_wp )  surf%r_a(m) = 1.0_wp
+!
+!--    Second step: calculate canopy resistance r_canopy
+!--    f1-f3 here are defined as 1/f1-f3 as in ECMWF documentation
  
-!--       f1: correction for incoming shortwave radiation (stomata close at 
-!--       night)
-          f1 = MIN( 1.0_wp, ( 0.004_wp * rad_sw_in(k,j,i) + 0.05_wp ) /        &
-                           (0.81_wp * (0.004_wp * rad_sw_in(k,j,i)             &
-                            + 1.0_wp)) )
-
-
-
-!
-!--       f2: correction for soil moisture availability to plants (the 
-!--       integrated soil moisture must thus be considered here)
-!--       f2 = 0 for very dry soils
-          m_total = 0.0_wp
-          DO  ks = nzb_soil, nzt_soil
-              m_total = m_total + root_fr(ks,j,i)                              &
-                        * MAX(m_soil(ks,j,i),m_wilt(j,i))
-          ENDDO 
-
-          IF ( m_total > m_wilt(j,i)  .AND.  m_total < m_fc(j,i) )  THEN
-             f2 = ( m_total - m_wilt(j,i) ) / (m_fc(j,i) - m_wilt(j,i) )
-          ELSEIF ( m_total >= m_fc(j,i) )  THEN
-             f2 = 1.0_wp
-          ELSE
-             f2 = 1.0E-20_wp
-          ENDIF
-
-!
-!--       Calculate water vapour pressure at saturation 
-          e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( t_surface(j,i)        &
-                        - 273.16_wp ) / ( t_surface(j,i) - 35.86_wp ) )
-
-!
-!--       f3: correction for vapour pressure deficit
-          IF ( g_d(j,i) /= 0.0_wp )  THEN
-!
-!--          Calculate vapour pressure
-             e  = qv1 * surface_pressure / 0.622_wp
-             f3 = EXP ( -g_d(j,i) * (e_s - e) )
-          ELSE
-             f3 = 1.0_wp
-          ENDIF
-
-!
-!--       Calculate canopy resistance. In case that c_veg is 0 (bare soils),
-!--       this calculation is obsolete, as r_canopy is not used below.
-!--       To do: check for very dry soil -> r_canopy goes to infinity
-          r_canopy(j,i) = r_canopy_min(j,i) / (lai(j,i) * f1 * f2 * f3         &
-                                          + 1.0E-20_wp)
-
-!
-!--       Third step: calculate bare soil resistance r_soil. The Clapp & 
-!--       Hornberger parametrization does not consider c_veg.
-          IF ( soil_type_2d(j,i) /= 7 )  THEN
-             m_min = c_veg(j,i) * m_wilt(j,i) + (1.0_wp - c_veg(j,i)) *        &
-                     m_res(j,i)
-          ELSE
-             m_min = m_wilt(j,i)
-          ENDIF
-
-          f2 = ( m_soil(nzb_soil,j,i) - m_min ) / ( m_fc(j,i) - m_min )
-          f2 = MAX(f2,1.0E-20_wp)
-          f2 = MIN(f2,1.0_wp)
-
-          r_soil(j,i) = r_soil_min(j,i) / f2
-
-!
-!--       Calculate the maximum possible liquid water amount on plants and
-!--       bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
-!--       assumed, while paved surfaces might hold up 1 mm of water. The 
-!--       liquid water fraction for paved surfaces is calculated after 
-!--       Noilhan & Planton (1989), while the ECMWF formulation is used for
-!--       vegetated surfaces and bare soils.
-          IF ( pave_surface(j,i) )  THEN
-             m_liq_eb_max = m_max_depth * 5.0_wp
-             c_liq(j,i) = MIN( 1.0_wp, (m_liq_eb(j,i) / m_liq_eb_max)**0.67 )
-          ELSE
-             m_liq_eb_max = m_max_depth * ( c_veg(j,i) * lai(j,i)              &
-                            + (1.0_wp - c_veg(j,i)) )
-             c_liq(j,i) = MIN( 1.0_wp, m_liq_eb(j,i) / m_liq_eb_max )
-          ENDIF
-
-!
-!--       Calculate saturation specific humidity
-          q_s = 0.622_wp * e_s / surface_pressure
-
-!
-!--       In case of dewfall, set evapotranspiration to zero
-!--       All super-saturated water is then removed from the air
-          IF ( humidity  .AND.  q_s <= qv1 )  THEN
-             r_canopy(j,i) = 0.0_wp
-             r_soil(j,i)   = 0.0_wp
-          ENDIF
-
-!
-!--       Calculate coefficients for the total evapotranspiration 
-!--       In case of water surface, set vegetation and soil fluxes to zero.
-!--       For pavements, only evaporation of liquid water is possible.
-          IF ( water_surface(j,i) )  THEN
-             f_qsws_veg  = 0.0_wp
-             f_qsws_soil = 0.0_wp
-             f_qsws_liq  = rho_lv / r_a(j,i)
-          ELSEIF ( pave_surface (j,i) )  THEN
-             f_qsws_veg  = 0.0_wp
-             f_qsws_soil = 0.0_wp
-             f_qsws_liq  = rho_lv * c_liq(j,i) / r_a(j,i)
-          ELSE
-             f_qsws_veg  = rho_lv * c_veg(j,i) * (1.0_wp - c_liq(j,i))/        &
-                           (r_a(j,i) + r_canopy(j,i))
-             f_qsws_soil = rho_lv * (1.0_wp - c_veg(j,i)) / (r_a(j,i) +        &
-                                                             r_soil(j,i))
-             f_qsws_liq  = rho_lv * c_veg(j,i) * c_liq(j,i) / r_a(j,i)
-          ENDIF
+!--    f1: correction for incoming shortwave radiation (stomata close at 
+!--    night)
+       f1 = MIN( 1.0_wp, ( 0.004_wp * rad_sw_in(k_rad,j+j_off,i+i_off) + 0.05_wp ) /&
+                        (0.81_wp * (0.004_wp * rad_sw_in(k_rad,j+j_off,i+i_off)&
+                         + 1.0_wp)) )
+!
+!--    f2: correction for soil moisture availability to plants (the 
+!--    integrated soil moisture must thus be considered here)
+!--    f2 = 0 for very dry soils
+       m_total = 0.0_wp
+       DO  ks = nzb_soil, nzt_soil
+           m_total = m_total + surf%root_fr(ks,m)                              &
+                     * MAX( surf_m_soil%var_2d(ks,m), surf%m_wilt(m) )
+       ENDDO 
+
+       IF ( m_total > surf%m_wilt(m)  .AND.                                    &
+            m_total < surf%m_fc(m) )  THEN
+          f2 = ( m_total - surf%m_wilt(m) ) /                                  &
+               ( surf%m_fc(m) - surf%m_wilt(m) )
+       ELSEIF ( m_total >= surf%m_fc(m) )  THEN
+          f2 = 1.0_wp
+       ELSE
+          f2 = 1.0E-20_wp
+       ENDIF
+!
+!--    Calculate water vapour pressure at saturation 
+       e_s = 0.01_wp * 610.78_wp * EXP( 17.269_wp * ( surf_t_surface%var_1d(m) &
+                     - 273.16_wp ) / ( surf_t_surface%var_1d(m) - 35.86_wp ) )
+!
+!--    f3: correction for vapour pressure deficit
+       IF ( surf%g_d(m) /= 0.0_wp )  THEN
+!
+!--       Calculate vapour pressure
+          e  = qv1 * surface_pressure / 0.622_wp
+          f3 = EXP ( - surf%g_d(m) * (e_s - e) )
+       ELSE
+          f3 = 1.0_wp
+       ENDIF
+!
+!--    Calculate canopy resistance. In case that c_veg is 0 (bare soils),
+!--    this calculation is obsolete, as r_canopy is not used below.
+!--    To do: check for very dry soil -> r_canopy goes to infinity
+       surf%r_canopy(m) = surf%r_canopy_min(m) /                               &
+                              ( surf%lai(m) * f1 * f2 * f3 + 1.0E-20_wp )
+!
+!--    Third step: calculate bare soil resistance r_soil. The Clapp & 
+!--    Hornberger parametrization does not consider c_veg.
+       IF ( surf%soil_type_2d(m) /= 7 )  THEN
+          m_min = surf%c_veg(m) * surf%m_wilt(m) +                             &
+                         ( 1.0_wp - surf%c_veg(m) ) * surf%m_res(m)
+       ELSE
+          m_min = surf%m_wilt(m)
+       ENDIF
+
+       f2 = ( surf_m_soil%var_2d(nzb_soil,m) - m_min ) / ( surf%m_fc(m) - m_min )
+       f2 = MAX( f2, 1.0E-20_wp )
+       f2 = MIN( f2, 1.0_wp     )
+
+       surf%r_soil(m) = surf%r_soil_min(m) / f2
+
+!
+!--    Calculate the maximum possible liquid water amount on plants and
+!--    bare surface. For vegetated surfaces, a maximum depth of 0.2 mm is
+!--    assumed, while paved surfaces might hold up 1 mm of water. The 
+!--    liquid water fraction for paved surfaces is calculated after 
+!--    Noilhan & Planton (1989), while the ECMWF formulation is used for
+!--    vegetated surfaces and bare soils.
+       IF ( surf%pave_surface(m) )  THEN
+          m_liq_eb_max = m_max_depth * 5.0_wp
+          surf%c_liq(m) = MIN( 1.0_wp, ( surf_m_liq_eb%var_1d(m) / m_liq_eb_max)**0.67 )
+       ELSE
+          m_liq_eb_max = m_max_depth * ( surf%c_veg(m) * surf%lai(m)&
+                            + ( 1.0_wp - surf%c_veg(m) ) )
+          surf%c_liq(m) = MIN( 1.0_wp, surf_m_liq_eb%var_1d(m) / m_liq_eb_max )
+       ENDIF
+!
+!--    Calculate saturation specific humidity
+       q_s = 0.622_wp * e_s / surface_pressure
+!
+!--    In case of dewfall, set evapotranspiration to zero
+!--    All super-saturated water is then removed from the air
+       IF ( humidity  .AND.  q_s <= qv1 )  THEN
+          surf%r_canopy(m) = 0.0_wp
+          surf%r_soil(m)   = 0.0_wp
+       ENDIF
+
+!
+!--    Calculate coefficients for the total evapotranspiration 
+!--    In case of water surface, set vegetation and soil fluxes to zero.
+!--    For pavements, only evaporation of liquid water is possible.
+       IF ( surf%water_surface(m) )  THEN
+          f_qsws_veg  = 0.0_wp
+          f_qsws_soil = 0.0_wp
+          f_qsws_liq  = rho_lv / surf%r_a(m)
+       ELSEIF ( surf%pave_surface (m) )  THEN
+          f_qsws_veg  = 0.0_wp
+          f_qsws_soil = 0.0_wp
+          f_qsws_liq  = rho_lv * surf%c_liq(m) / surf%r_a(m)
+       ELSE
+          f_qsws_veg  = rho_lv * surf%c_veg(m) *                               &
+                            ( 1.0_wp        - surf%c_liq(m)    ) /             &
+                            ( surf%r_a(m) + surf%r_canopy(m) )
+          f_qsws_soil = rho_lv * (1.0_wp    - surf%c_veg(m)    ) /             &
+                            ( surf%r_a(m) + surf%r_soil(m)   )
+          f_qsws_liq  = rho_lv * surf%c_veg(m) * surf%c_liq(m)   /             &
+                              surf%r_a(m)
+       ENDIF
 !
 !--       If soil moisture is below wilting point, plants do no longer
